#import "SaveController.h"

@implementation SaveController

- (void)awakeFromNib
{
    [newButton   setEnabled:YES];
    [saveButton  setEnabled:NO];
    [loadButton  setEnabled:YES];
    [editButton  setEnabled:NO];
    [cleanButton setEnabled:NO];

    [fieldA setStringValue:@""];
    [fieldB setStringValue:@""];
    [fieldC setStringValue:@""];
}

- (void) displayAnObject; 
{
   [fieldA setIntValue:    [anObject a]]; 
   [fieldB setFloatValue:  [anObject b]]; 
   [fieldC setStringValue: [anObject c]]; 
}

- (IBAction)save:(id)sender
{
   id panel; 
   NSString *dir; 
   NSString *file; 
   BOOL wr; 
   int runResult;

//   panel = [NSSavePanel new];
   dir = NSHomeDirectory(); 
   file  = [NSString stringWithString:@"noname"]; 

   panel = [NSSavePanel new];
   [panel setRequiredFileType:@"data"]; 
   runResult = [panel runModalForDirectory:dir file:file];
   if (runResult == NSOKButton) {
      file = [panel filename]; 
      wr   = [NSArchiver archiveRootObject:anObject toFile:file];
      if (!wr) {
         NSRunAlertPanel(SAVE_TITLE, DIR_NOT_WRITABLE, nil, nil, nil);
         return; 
      }
      else {
        [newButton   setEnabled:YES]; 
        [saveButton  setEnabled:YES]; 
        [loadButton  setEnabled:YES]; 
        [editButton  setEnabled:YES];
        [cleanButton setEnabled:YES];
      }
   }
   [panel release]; 
}

- (IBAction)newObject:(id)sender
{
   if (anObject!=nil) [anObject release]; 
   anObject = [[UnaClase alloc] initWith: 0: 0.0: @""]; 
   [newButton  setEnabled:NO]; 
   [saveButton setEnabled:NO]; 
   [loadButton setEnabled:NO]; 
   [editButton setEnabled:YES];
   [cleanButton setEnabled:YES];
   [self displayAnObject]; 
}

- (IBAction)load:(id)sender
{
//    int index, numFiles; 
    char *fn; 
    NSString *dir;
    NSArray *files;
    NSString *fullPath=nil; 
    NSArray *fileTypes = [[[NSArray alloc] 
            initWithObjects:@"data", nil] autorelease];
    NSOpenPanel *panel = [NSOpenPanel openPanel];
    dir = NSHomeDirectory(); 
    [panel setDirectory:dir]; 
    if ([panel runModalForTypes:fileTypes]) {
        files = [panel filenames];
        fullPath = [files objectAtIndex:0];
    }

    fn = [fullPath cString];
    printf("archivo a leer %s\n", fn);

    if (anObject=nil) [anObject release];
    anObject = [[NSUnarchiver unarchiveObjectWithFile:fullPath] retain];
    [self displayAnObject]; 
    [newButton  setEnabled:NO]; 
    [saveButton setEnabled:YES]; 
    [loadButton setEnabled:NO]; 
    [editButton setEnabled:YES];
    [cleanButton setEnabled:YES];
}

- (IBAction)set:(id)sender
{
   int a; 
   float b; 
   char *c; 
   [anObject setA: [fieldA intValue]]; 
   [anObject setB: [fieldB floatValue]]; 
   [anObject setC: [fieldC stringValue]];    
   a = [anObject a]; 
   b = [anObject b]; 
   c = [[anObject c] cString]; 
   printf("[%d][%f][%s]\n", a, b, c);
   [newButton  setEnabled:NO]; 
   [saveButton setEnabled:YES]; 
   [loadButton setEnabled:NO]; 
   [cleanButton setEnabled:NO]; 
}

- (IBAction)clean:(id)sender
{
   if (anObject!=nil) [anObject release]; 
   [fieldA setStringValue:@""];
   [fieldB setStringValue:@""];
   [fieldC setStringValue:@""];
   [newButton  setEnabled:YES]; 
   [saveButton setEnabled:NO]; 
   [loadButton setEnabled:YES]; 
   [editButton setEnabled:NO]; 
}

@end
